Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 824)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 825)
@@ -1003,4 +1003,7 @@
   ("CGSMaxYPartNumLog",  m_nCGSMaxYPartNumLog2 , 2, "max Y part number ")
   ("CGSLUTBit",     m_nCGSLUTBit , 12, "bit depth of CGS LUT")
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  ("CGSAdaptC",     m_nCGSAdaptiveChroma , 1, "adaptive chroma partition (only for the case of two chroma partitions)")
+#endif
 #endif
 #if Q0108_TSA_STSA
@@ -3087,4 +3090,7 @@
   printf("CGS: %d CGSMaxOctantDepth: %d CGSMaxYPartNumLog2: %d CGSLUTBit:%d " , m_nCGSFlag , m_nCGSMaxOctantDepth , m_nCGSMaxYPartNumLog2 , m_nCGSLUTBit );
 #endif
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  printf("CGSAdaptC:%d " , m_nCGSAdaptiveChroma );
+#endif
   printf("\n\n");
   
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 824)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 825)
@@ -435,5 +435,8 @@
   Int  m_nCGSMaxYPartNumLog2;
   Int  m_nCGSLUTBit;
-#endif
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  Int  m_nCGSAdaptiveChroma;
+#endif
+#endif 
 #endif //SVC_EXTENSION
 public:
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 824)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 825)
@@ -650,4 +650,7 @@
     m_acTEncTop[layer].setCGSMaxYPartNumLog2( m_nCGSMaxYPartNumLog2 );
     m_acTEncTop[layer].setCGSLUTBit( m_nCGSLUTBit );
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+    m_acTEncTop[layer].setCGSAdaptChroma( m_nCGSAdaptiveChroma );
+#endif
 #endif
 #if Q0078_ADD_LAYER_SETS
Index: /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.cpp	(revision 824)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.cpp	(revision 825)
@@ -17,4 +17,7 @@
   m_pCuboid = NULL;
   m_nResQuanBit = 0;
+#if R0164_CGS_LUT_BUGFIX
+  m_pCuboidExplicit = NULL;
+#endif
 }
 
@@ -24,5 +27,9 @@
 }
 
-Void TCom3DAsymLUT::create( Int nMaxOctantDepth , Int nInputBitDepth , Int nInputBitDepthC , Int nOutputBitDepth , Int nOutputBitDepthC , Int nMaxYPartNumLog2 )
+Void TCom3DAsymLUT::create( Int nMaxOctantDepth , Int nInputBitDepth , Int nInputBitDepthC , Int nOutputBitDepth , Int nOutputBitDepthC , Int nMaxYPartNumLog2 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  , Int nAdaptCThresholdU , Int nAdaptCThresholdV
+#endif
+  )
 {
   m_nMaxOctantDepth = nMaxOctantDepth;
@@ -36,5 +43,9 @@
   m_nMaxPartNumLog2 = 3 * m_nMaxOctantDepth + m_nMaxYPartNumLog2;
 
-  xUpdatePartitioning( nMaxOctantDepth , nMaxYPartNumLog2 );
+  xUpdatePartitioning( nMaxOctantDepth , nMaxYPartNumLog2 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+    , nAdaptCThresholdU , nAdaptCThresholdV
+#endif
+    );
 
   m_nYSize = 1 << ( m_nMaxOctantDepth + m_nMaxYPartNumLog2 );
@@ -48,4 +59,8 @@
   }
   xAllocate3DArray( m_pCuboid , m_nYSize , m_nUSize , m_nVSize );
+
+#if R0164_CGS_LUT_BUGFIX
+  xAllocate3DArray( m_pCuboidExplicit , m_nYSize , m_nUSize , m_nVSize );
+#endif
 }
 
@@ -53,7 +68,14 @@
 {
   xFree3DArray( m_pCuboid );
-}
-
-Void TCom3DAsymLUT::xUpdatePartitioning( Int nCurOctantDepth , Int nCurYPartNumLog2 )
+#if R0164_CGS_LUT_BUGFIX
+  xFree3DArray( m_pCuboidExplicit  );
+#endif
+}
+
+Void TCom3DAsymLUT::xUpdatePartitioning( Int nCurOctantDepth , Int nCurYPartNumLog2 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  , Int nAdaptCThresholdU , Int nAdaptCThresholdV
+#endif
+  )
 {
   assert( nCurOctantDepth <= m_nMaxOctantDepth );
@@ -64,5 +86,11 @@
   m_nYShift2Idx = m_nInputBitDepthY - m_nCurOctantDepth - m_nCurYPartNumLog2;
   m_nUShift2Idx = m_nVShift2Idx = m_nInputBitDepthC - m_nCurOctantDepth;
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  m_nMappingShift = 10 + m_nInputBitDepthY - m_nOutputBitDepthY; 
+  m_nAdaptCThresholdU = nAdaptCThresholdU;
+  m_nAdaptCThresholdV = nAdaptCThresholdV;
+#else
   m_nMappingShift = m_nYShift2Idx + m_nUShift2Idx;
+#endif
   m_nMappingOffset = 1 << ( m_nMappingShift - 1 );
 }
@@ -159,7 +187,17 @@
   
   SYUVP sPred;
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  sPred.Y = sPred.U = sPred.V = 0;
+  if( nVertexIdx == 0 )
+    sPred.Y = xGetNormCoeffOne() << ( m_nOutputBitDepthY - m_nInputBitDepthY );
+  else if( nVertexIdx == 1 )
+    sPred.U = xGetNormCoeffOne() << ( m_nOutputBitDepthY - m_nInputBitDepthY );
+  else if( nVertexIdx == 2 )
+    sPred.V = xGetNormCoeffOne() << ( m_nOutputBitDepthY - m_nInputBitDepthY );
+#else
   sPred.Y = ( yIdx + m_nVertexIdxOffset[nVertexIdx][0] ) << ( m_nYShift2Idx + m_nDeltaBitDepth );
   sPred.U = ( uIdx + m_nVertexIdxOffset[nVertexIdx][1] ) << ( m_nUShift2Idx + m_nDeltaBitDepthC );
   sPred.V = ( vIdx + m_nVertexIdxOffset[nVertexIdx][2] ) << ( m_nVShift2Idx + m_nDeltaBitDepthC );
+#endif
   return( sPred );
 }
@@ -169,4 +207,17 @@
   SCuboid***  pCuboid = pCurCuboid ? pCurCuboid : m_pCuboid ;
 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  SYUVP sPred;
+  if( yIdx == 0 )
+  {
+    sPred.Y = nVertexIdx == 0 ? 1024 : 0;
+    sPred.U = nVertexIdx == 1 ? 1024 : 0;
+    sPred.V = nVertexIdx == 2 ? 1024 : 0;
+  }
+  else
+  {
+    sPred = pCuboid[yIdx-1][uIdx][vIdx].P[nVertexIdx];
+  }
+#else
   // PredA
   SYUVP sPredA = xGetCuboidVertexPredA( yIdx , uIdx , vIdx , nVertexIdx );
@@ -196,5 +247,5 @@
   sPred.U = sPredA.U + sPredB.U;
   sPred.V = sPredA.V + sPredB.V;
-
+#endif
   return sPred ;
 }
@@ -220,8 +271,18 @@
   rYUVP.U = sPred.U + ( deltaU << m_nResQuanBit );
   rYUVP.V = sPred.V + ( deltaV << m_nResQuanBit );
+#if R0150_CGS_SIGNAL_CONSTRAINTS
+  // LUT coefficients are less than 12-bit
+  assert( -2048 <= rYUVP.Y && rYUVP.Y <= 2047 );
+  assert( -2048 <= rYUVP.U && rYUVP.U <= 2047 );
+  assert( -2048 <= rYUVP.V && rYUVP.V <= 2047 );
+#endif
 }
 
 Pel TCom3DAsymLUT::xMapY( Pel y , Pel u , Pel v )
 {
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  const SCuboid & rCuboid = m_pCuboid[xGetYIdx(y)][xGetUIdx(u)][xGetVIdx(v)];
+  Pel dstY = ( ( rCuboid.P[0].Y * y + rCuboid.P[1].Y * u + rCuboid.P[2].Y * v + m_nMappingOffset ) >> m_nMappingShift ) + rCuboid.P[3].Y;
+#else
   const SCuboid & rCuboid = m_pCuboid[y>>m_nYShift2Idx][u>>m_nUShift2Idx][v>>m_nVShift2Idx];
   Pel dstY = rCuboid.P[0].Y;
@@ -233,4 +294,5 @@
                    + ( ( deltaV * ( rCuboid.P[2].Y - rCuboid.P[1].Y ) ) << m_nYShift2Idx ) 
                    + m_nMappingOffset ) >> m_nMappingShift );
+#endif
   return( dstY );
 }
@@ -238,4 +300,11 @@
 SYUVP TCom3DAsymLUT::xMapUV( Pel y , Pel u , Pel v )
 {
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  const SCuboid & rCuboid = m_pCuboid[xGetYIdx(y)][xGetUIdx(u)][xGetVIdx(v)];
+  SYUVP dst;
+  dst.Y = 0;
+  dst.U = ( ( rCuboid.P[0].U * y + rCuboid.P[1].U * u + rCuboid.P[2].U * v + m_nMappingOffset ) >> m_nMappingShift ) + rCuboid.P[3].U;
+  dst.V = ( ( rCuboid.P[0].V * y + rCuboid.P[1].V * u + rCuboid.P[2].V * v + m_nMappingOffset ) >> m_nMappingShift ) + rCuboid.P[3].V;
+#else
   const SCuboid & rCuboid = m_pCuboid[y>>m_nYShift2Idx][u>>m_nUShift2Idx][v>>m_nVShift2Idx];
   SYUVP dst = rCuboid.P[0];
@@ -251,4 +320,5 @@
                     + ( ( deltaV * ( rCuboid.P[2].V - rCuboid.P[1].V ) ) << m_nYShift2Idx ) 
                     + m_nMappingOffset ) >> m_nMappingShift );
+#endif
   return( dst );
 }
@@ -262,9 +332,83 @@
 {
   assert( pSrc->getMaxOctantDepth() == getMaxOctantDepth() && pSrc->getMaxYPartNumLog2() == getMaxYPartNumLog2() );
-  xUpdatePartitioning( pSrc->getCurOctantDepth() , pSrc->getCurYPartNumLog2() );
+  xUpdatePartitioning( pSrc->getCurOctantDepth() , pSrc->getCurYPartNumLog2() 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+    , pSrc->getAdaptChromaThresholdU() , pSrc->getAdaptChromaThresholdV()
+#endif
+    );
   setResQuantBit( pSrc->getResQuantBit() );
   xSaveCuboids( pSrc->m_pCuboid );
 }
 
-#endif
-
+#if R0164_CGS_LUT_BUGFIX
+Void TCom3DAsymLUT::xInitCuboids( )
+{
+  // All vertices are initialized as non-exlicitly-encoded
+  for( Int yIdx = 0 ; yIdx < m_nYSize ; yIdx++ )
+  {
+    for( Int uIdx = 0 ; uIdx < m_nUSize ; uIdx++ )
+    {
+      for( Int vIdx = 0 ; vIdx < m_nVSize ; vIdx++ )
+      { 
+        m_pCuboidExplicit[yIdx][uIdx][vIdx] = false;
+      }
+    }
+  }
+}
+
+Void TCom3DAsymLUT::xCuboidsExplicitCheck( Int yIdx , Int uIdx , Int vIdx )
+{
+  if ( m_pCuboidExplicit[yIdx][uIdx][vIdx] == false )
+  {
+    if( yIdx > 0) 
+      assert ( m_pCuboidExplicit[yIdx-1][uIdx][vIdx] );
+
+    for ( Int nVertexIdx=0 ; nVertexIdx<4 ; nVertexIdx++ )
+      m_pCuboid[yIdx][uIdx][vIdx].P[nVertexIdx] = yIdx == 0 ? xGetCuboidVertexPredA( yIdx , uIdx , vIdx , nVertexIdx ): xGetCuboidVertexPredAll( yIdx , uIdx , vIdx , nVertexIdx );
+
+    m_pCuboidExplicit[yIdx][uIdx][vIdx] = true ;
+  }
+}
+
+
+Void TCom3DAsymLUT::xCuboidsExplicitCheck( Bool bDecode )
+{
+  Int ySize = 1 << ( getCurOctantDepth() + getCurYPartNumLog2() );
+  Int uSize = 1 << getCurOctantDepth();
+  Int vSize = 1 << getCurOctantDepth();
+  for( Int yIdx = 0 ; yIdx < ySize ; yIdx++ )
+  {
+    for( Int uIdx = 0 ; uIdx < uSize ; uIdx++ )
+    {
+      for( Int vIdx = 0 ; vIdx < vSize ; vIdx++ )
+      { 
+        if ( bDecode )
+          xCuboidsExplicitCheck( yIdx , uIdx , vIdx );
+
+        assert( m_pCuboidExplicit[yIdx][uIdx][vIdx] );
+      }
+    }
+  }
+
+}
+#endif
+
+#if R0150_CGS_SIGNAL_CONSTRAINTS
+Bool TCom3DAsymLUT::isRefLayer( UInt uiRefLayerId )
+{
+  Bool bIsRefLayer = false;
+  for( UInt i = 0 ; i < m_vRefLayerId.size() ; i++ )
+  {
+    if( m_vRefLayerId[i] == uiRefLayerId )
+    {
+      bIsRefLayer = true;
+      break;
+    }
+  }
+
+  return( bIsRefLayer );
+}
+#endif
+
+#endif
+
Index: /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.h	(revision 824)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TCom3DAsymLUT.h	(revision 825)
@@ -4,4 +4,8 @@
 
 #include "TypeDef.h"
+#if R0150_CGS_SIGNAL_CONSTRAINTS
+#include <cassert>
+#include <vector>
+#endif
 
 #if Q0048_CGS_3D_ASYMLUT
@@ -25,5 +29,9 @@
   virtual ~TCom3DAsymLUT();
 
-  virtual Void  create( Int nMaxOctantDepth , Int nInputBitDepth , Int nInputBitDepthC , Int nOutputBitDepth , Int nOutputBitDepthC , Int nMaxYPartNumLog2 );
+  virtual Void  create( Int nMaxOctantDepth , Int nInputBitDepth , Int nInputBitDepthC , Int nOutputBitDepth , Int nOutputBitDepthC , Int nMaxYPartNumLog2 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  , Int nAdaptCThresholdU , Int nAdaptCThresholdV
+#endif
+    );
   virtual Void  destroy();
 
@@ -38,4 +46,20 @@
   Int   getMaxYPartNumLog2() { return m_nMaxYPartNumLog2; }
   Int   getCurYPartNumLog2() { return m_nCurYPartNumLog2; }
+#if R0150_CGS_SIGNAL_CONSTRAINTS
+  Void  addRefLayerId( UInt uiRefLayerId )  
+  { 
+    if( !isRefLayer( uiRefLayerId ) )
+      m_vRefLayerId.push_back( uiRefLayerId ); 
+  }
+  size_t  getRefLayerNum()     { return m_vRefLayerId.size();  }
+  UInt  getRefLayerId( UInt n )  { assert( n < m_vRefLayerId.size() ); return m_vRefLayerId[n];   }
+  Bool  isRefLayer( UInt uiRefLayerId );
+#endif
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  Void  setAdaptChromaThresholdU( Int n ) { m_nAdaptCThresholdU = n; }
+  Int   getAdaptChromaThresholdU()        { return m_nAdaptCThresholdU; }
+  Void  setAdaptChromaThresholdV( Int n ) { m_nAdaptCThresholdV = n;  }
+  Int   getAdaptChromaThresholdV()        { return m_nAdaptCThresholdV; }
+#endif
 
   Void  colorMapping( TComPicYuv * pcPicSrc,  TComPicYuv * pcPicDst );
@@ -45,5 +69,10 @@
   SYUVP getCuboidVertexResTree( Int yIdx , Int uIdx , Int vIdx , Int nVertexIdx );
   Void  setCuboidVertexResTree( Int yIdx , Int uIdx , Int vIdx , Int nVertexIdx , Int deltaY , Int deltaU , Int deltaV );
-
+#if R0164_CGS_LUT_BUGFIX
+  Void  xInitCuboids( );
+  Void  xCuboidsExplicitCheck( Int yIdx , Int uIdx , Int vIdx );
+  Void  xCuboidsExplicitCheck( Bool bDecode );
+  Void  xSetExplicit( Int yIdx , Int uIdx , Int vIdx )  { m_pCuboidExplicit[yIdx][uIdx][vIdx] = true ;}
+#endif
 
 private:
@@ -70,4 +99,14 @@
   SCuboid *** m_pCuboid;
   const static Int m_nVertexIdxOffset[4][3];
+#if R0150_CGS_SIGNAL_CONSTRAINTS
+  std::vector<UInt> m_vRefLayerId;
+#endif
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  Int   m_nAdaptCThresholdU;
+  Int   m_nAdaptCThresholdV;
+#endif
+#if R0164_CGS_LUT_BUGFIX
+  Bool  *** m_pCuboidExplicit;
+#endif
 
 protected:
@@ -79,5 +118,9 @@
   Void xFree3DArray( T *** &p );
 
-  Void  xUpdatePartitioning( Int nCurOctantDepth , Int nCurYPartNumLog2 );
+  Void  xUpdatePartitioning( Int nCurOctantDepth , Int nCurYPartNumLog2 
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+    , Int nAdaptCThresholdU , Int nAdaptCThreshodV
+#endif
+    );
   SYUVP xGetCuboidVertexPredA( Int yIdx , Int uIdx , Int vIdx , Int nVertexIdx );
   Pel   xMapY( Pel y , Pel u , Pel v );
@@ -87,7 +130,14 @@
   Int   xGetUSize()  { return m_nUSize;  }
   Int   xGetVSize()  { return m_nVSize;  }
+#if R0151_CGS_3D_ASYMLUT_IMPROVE
+  Int   xGetYIdx(Pel y)  { return( y >> m_nYShift2Idx ); }
+  Int   xGetUIdx(Pel u)  { return( m_nCurOctantDepth == 1 ? u >= m_nAdaptCThresholdU : u >> m_nUShift2Idx ); }
+  Int   xGetVIdx(Pel v)  { return( m_nCurOctantDepth == 1 ? v >= m_nAdaptCThresholdV : v >> m_nVShift2Idx ); }
+  Int   xGetNormCoeffOne()    { return( 1 << m_nMappingShift ); }
+#else
   Int   xGetYShift2Idx() { return m_nYShift2Idx; }
   Int   xGetUShift2Idx() { return m_nUShift2Idx; }
   Int   xGetVShift2Idx() { return m_nVShift2Idx; } 
+#endif
   SCuboid & xGetCuboid( Int yIdx , Int uIdx , Int vIdx ){ return m_pCuboid[yIdx][uIdx][vIdx];  }
   Void  xSaveCuboids( SCuboid *** pSrcCuboid );
Index: /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 824)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 825)
@@ -93,8 +93,9 @@
 #if Q0048_CGS_3D_ASYMLUT
 #define CGS_GCC_NO_VECTORIZATION         1
-#define O0194_WEIGHTED_PREDICTION_CGS    0
-#else
+#define R0150_CGS_SIGNAL_CONSTRAINTS     1      ///< JCTVC-R0150: CGS signaling improvement and constraints
+#define R0151_CGS_3D_ASYMLUT_IMPROVE     1      ///< JCTVC-R0151: Non-uniform chroma partitioning and improved LUT coefficient coding
+#define R0164_CGS_LUT_BUGFIX             1      ///< JCTVC-R0164: Bug fix with LUT syntax
+#endif
 #define O0194_WEIGHTED_PREDICTION_CGS    1      ///< JCTVC-O0194: Weighted prediciton for color gamut scalability
-#endif
 #define POC_RESET_FLAG                   0      ///< JCTVC-N0244: POC reset flag for  layer pictures.
 #define POC_RESET_IDC                    1      ///< JCTVC-P0041: Include poc_reset_idc and related derivation - eventually will replace POC_RESET_FLAG
